package qr;

import java.io.IOException;
import java.util.StringTokenizer;

public class Reading implements Runnable{
	int buffsize = 0;
//	int threadNo;
//	String date;
//	public String swf;
	Qr qr;
	TextCGI textCGI;
	String getbuffer;
	StringTokenizer tk;
	Thread thread;
	boolean running;
	
	public Reading(Qr qr, TextCGI textCGI, int threadNo){
		try {
			this.qr = qr;
			this.textCGI = textCGI;
//			this.threadNo = threadNo;
			textCGI.connect();
			getbuffer = textCGI.get();
			buffsize = getbuffer.length();
			thread = new Thread(this);
			running = true;
			thread.start();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private String parseMobile(int mobnum){
		String mobile = "";
		switch(mobnum){
		case 0:
			mobile = "PC User";
			break;
		case 1:
			mobile = "Docomo User";
			break;
		case 2:
			mobile = "AU User";
			break;
		case 3:
			mobile = "SoftBank User";
			break;
		}
		return mobile;
	}
	
	public void run(){
		try {
			while(running){
				textCGI.connect();
				getbuffer = textCGI.get();
				if(buffsize < getbuffer.length()){
					int buflength = getbuffer.length();
					getbuffer = getbuffer.substring(buffsize);
					buffsize = buflength;
					String lognumnow = "mobnum=";
					int indexnum = getbuffer.indexOf(lognumnow);
					if(indexnum != -1){
						tk = new StringTokenizer(getbuffer, ",");
						int mobnum = 0;
						int sendmob = 0;
						String swf = "";
						String word = "";
						System.out.println("-----Mobile info-------------------------");
						while(tk.hasMoreTokens()){
							
							String buff = tk.nextToken();
							if(buff.startsWith("mobnum=")){
								System.out.println("Read From :" + tk);
								mobnum = (int)buff.charAt(7) - 48;
								sendmob = (int)buff.charAt(9) - 48;
								String receiver = parseMobile(mobnum);
								String sender = parseMobile(sendmob);
								System.out.println("User : " + receiver);
								System.out.println("Read From :" + sender);
							}else if(buff.startsWith("&swf=")){
								swf = buff.substring(5);
								System.out.println("(IP_QRtype) : (" + swf + ")");
							}else if(buff.startsWith("&word=")){
								word = buff.substring(6);
								System.out.println("ID : " + word);
								Qr.addSeq(swf, word, mobnum, sendmob);
							}
						}
						System.out.println("-----------------------------------------");
						System.out.println("");
					}
				}else{
					Thread.sleep(100);
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

	}

}
