package qr.object;

import java.util.ArrayList;

import qr.Qr;

public class FrontText {
	Qr qr;
	String freq = "qr: ver1.0";
	float w = 0;
	int cnt = 0;
	int[] thread = {300, 302, 304, 306, 308, 310, 312, 314, 316, 318, 320};
	int[] thread2 = {308, 310, 312, 314, 316, 318, 320, 322, 324, 326, 328};
	int rot = 0;
	private ArrayList front = new ArrayList();
	private boolean reloading = false;
	
	public FrontText(Qr qr){
		this.qr = qr;
		qr.textFont(qr.getMiddleFont(), qr.getMiddleFontSize());
		for(int i = 0; i < freq.length(); i++){
			Word word = new Word(qr, w + qr.width * 0.7f, qr.height - qr.getMiddleFontSize() * 0.7f);
			word.setKey(freq.charAt(i));
			front.add(i, word);
			w += qr.textWidth(freq.charAt(i));
		}
	}
	
	public void draw(){
		if(!reloading){
			for(int i = 0; i < front.size(); i++){
				((Word)front.get(i)).draw();
			}
			cnt++;
			for(int i = 0; i < front.size(); i++){
				if(cnt > thread[i]){
					((Word)front.get(i)).setTrad((cnt-thread[i])*43);
				}
				if(cnt > thread2[i]){
					((Word)front.get(i)).setTrad(0);
				}
			}
			if(cnt > 1000)
				cnt = 0;
		}else{
			cnt++;
			if(cnt > 20){
				reloading = false;
				cnt = 0;
			}
		}
	}
	
	public void reloadFront(){
		reloading = true;
		w = 0;
		front = new ArrayList();
		qr.textFont(qr.getMiddleFont(), qr.getMiddleFontSize());
		for(int i = 0; i < freq.length(); i++){
			Word word = new Word(qr, w + qr.width * 0.7f, qr.height - qr.getMiddleFontSize() * 0.7f);
			word.setKey(freq.charAt(i));
			front.add(i, word);
			w += qr.textWidth(freq.charAt(i));
		}
	}
}
