/*
 * 쐬: 2006/02/25
 *
 * TODO ̐ꂽt@C̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */
package qr.synth;

import com.softsynth.jsyn.LineOut;
import com.softsynth.jsyn.Synth;
import com.softsynth.jsyn.SynthMixer;
import com.softsynth.jsyn.SynthOutput;

/**
 * @author samb
 *
 * ~LT[ƃV[PT[TEhRA
 * ~LT[
 * @Eo͂~LT[̓͂ɐڑ
 * @Eڑς݂̏o͂؂藣B
 * V[PT[
 * @EIuWFNg̓o^
 * @Eo^IuWFNgNI^CY䂷B
 */
public class Mixer {

	private LineOut lineOut;
	/**
	 * <code>mm</code> ̃Rg
	 * ~LT[̃CX^X͓͐K
	 * o͂
	 * @CAEg@		~@Qch
	 * @ZhGtFNg@	~@Qch
	 */
	private SynthMixer mixer;
	private static boolean[] mixerUsedPort;

	private static int MIXER_INPUT = 50;
	private static int MIXER_OUTPUT = 4;

	public Mixer(){
		Synth.startEngine(0);
		
		mixerUsedPort = new boolean[MIXER_INPUT];
		
		lineOut  = new LineOut();
		mixer = new SynthMixer(MIXER_INPUT, MIXER_OUTPUT);
		mixer.connectOutput(0, lineOut.input, 0);
		mixer.connectOutput(1, lineOut.input, 1);

		mixer.start();
		lineOut.start();
	}
	
	/***********************************************************************
	 * ~LT[E\bh
	 ***********************************************************************/
	
	/**
	 * @param out
	 * o͂̃|[gԂA~LT[̓͂ɐڑ
	 * 󂢂Ă̓|[gT[`ĂɐڑB
	 * @return
	 * ڑ|[gԍ߂lƂĕԂB
	 * ڑs̏ꍇ-1ԂB
	 */
	public int connectOutputToMixer(SynthOutput out) {
		int connectPort = -1;
		/*
		 * out̃`lŕ
		 */
		switch(out.getNumParts()) {
		case 1:
			connectPort = monoConnect(out);
			break;
		case 2:
			connectPort = stereoConnect(out);
			break;
		default:
			System.out.println("Mixer connection Error (Too Many Channel)\n");
			break;
		}
		return connectPort;
	}
	
	private int stereoConnect(SynthOutput out) {
		int inputPort = searchEmptyPort(2);
		if(inputPort < 0) {
			System.out.println("Empty Port is nothing! connection is failed.\n");
			return -1;
		}
		mixer.connectInput(inputPort, out, 0); 		// outL`ڑ
		mixer.connectInput(inputPort+1, out, 1);	// outR`ڑ
		mixer.setGain(inputPort,   0, 1.0);	// outL` - LineL`@QC1.0
		mixer.setGain(inputPort,   1, 0.0);	// outL` - LineR`@QC0.0ij
		mixer.setGain(inputPort+1, 0, 0.0);	// outR` - LineL`@QC0.0ij
		mixer.setGain(inputPort+1, 1, 1.0);	// outR` - LineR`@QC1.0
		return inputPort;
	}
	
	private int monoConnect(SynthOutput out) {
		int inputPort = searchEmptyPort(1);
		if(inputPort < 0) {
			System.out.println("Empty Port is nothing! connection is failed.\n");
			return -1;
		}
		mixer.connectInput(inputPort, out, 0); 		// out̏óimonojڑ
		mixer.setGain(inputPort,   0, 1.0);	// outL` - LineL`@QC1.0
		mixer.setGain(inputPort,   1, 1.0);	// outL` - LineR`@QC1.0
		return inputPort;
	}
	
	/**
	 * @param numChannel
	 * @return
	 * Ŏw肵󂢂Ă~LT[̓̓|[g̔ԍԂ
	 * ǂ̃|[g󂢂ĂȂꍇ-1Ԃ
	 */
	public int searchEmptyPort(int numChannel) {
		boolean flag = false;
		int port = 0;
		while(true) {
			if(port+numChannel >= MIXER_INPUT) {
				port = -1;
				break;
			}
			
			flag = true;	// portԖڂ̃|[g`lԂ󂢂Ă邩`FbN
			for(int n = 0; n < numChannel; n++) {
				if(mixerUsedPort[port+n]) {
					flag = false;
				}
			}
			if(flag) {		// |[g`lԂ󂢂Ă
				for(int n = 0; n < numChannel; n++) {
					mixerUsedPort[port+n] = true; // gpς݃|[gƂ
				}
				break;
			}
			
			port++;			// ̃|[gT
		}
		return port;
	}
	
	
	/**
	 * @param portnum
	 * @param out
	 * portnumŎw肵|[gԍout|[gԂ
	 * 󂫃|[gƂB
	 * łout̐ڑ؂藣B
	 */
	public static void disconnectOutputFromMixer(int portnum, int thisportnum) {
		if( portnum+/*out.getNumParts()*/ thisportnum < MIXER_INPUT) {
			for(int i = portnum; i < portnum+/*out.getNumParts()*/thisportnum; i++) {
				mixerUsedPort[i] = false; 			// 󂫃|[gƂ
			}
//			out.disconnect();
		}
	}
}
